#include <iostream>
#include <memory>

class Object {
	int value;

public:
	Object(int v)
	    : value(v) { std::cout << "constructor with " << value << '\n'; }
	~Object() { std::cout << "destructor " << value << '\n'; }
	int getValue() const { return value; }
};

void foo(const Object& obj) {
	std::cout << "in foo with " << obj.getValue() << '\n';
}

int main() {
	auto ptr = std::make_unique<Object>(1);
	{
		auto ptr2 = std::make_unique<Object>(2);
		std::cout << ptr2->getValue() << '\n';
	}
	foo(*ptr);

	auto ptr3 = std::make_unique<Object>(3);
	ptr3.reset();
	std::cout << "main after reset\n";
}
