#include <iostream>
#include <memory>

class Object {
	int value;

public:
	Object(int v)
	    : value(v) { std::cout << "constructor with " << value << '\n'; }
	~Object() { std::cout << "destructor " << value << '\n'; }
	int getValue() const { return value; }
};

int main() {
	std::unique_ptr<Object> ptr;
	if (!ptr) {
		std::cout << "ptr is nullptr\n";
	}

	ptr = std::make_unique<Object>(421);

	if (ptr) {
		std::cout << "ptr is valid pointer\n";
	}

	Object* raw = ptr.get();

	std::cout << raw->getValue() << '\n';

	// Object's memory is freed
	// what happens if we change get() to release()? (hint: valgrind)
}
